Index: fluid/Fl_Widget_Type.cxx
===================================================================
RCS file: /cvsroot/fltk/fltk/fluid/Fl_Widget_Type.cxx,v
retrieving revision 1.15.2.16.2.24
diff -u -r1.15.2.16.2.24 Fl_Widget_Type.cxx
--- fluid/Fl_Widget_Type.cxx	18 May 2003 22:12:19 -0000	1.15.2.16.2.24
+++ fluid/Fl_Widget_Type.cxx	27 May 2003 20:13:49 -0000
@@ -955,8 +955,8 @@
       if (i->window()) i->window()->make_current();
       haderror = 1;
     }
-    for (Fl_Type *o = Fl_Type::first; o; o = o->next) if (o->selected) {
-      o->callback(c);
+    for (Fl_Type *o = Fl_Type::first; o; o = o->next) {
+      if (o->selected) o->callback(c);
     }
     free(c);
   }
Index: src/Fl_Text_Editor.cxx
===================================================================
RCS file: /cvsroot/fltk/fltk/src/Fl_Text_Editor.cxx,v
retrieving revision 1.9.2.15
diff -u -r1.9.2.15 Fl_Text_Editor.cxx
--- src/Fl_Text_Editor.cxx	1 Apr 2003 20:14:16 -0000	1.9.2.15
+++ src/Fl_Text_Editor.cxx	27 May 2003 20:13:49 -0000
@@ -187,7 +187,8 @@
   if (e->insert_mode()) e->insert(s);
   else e->overstrike(s);
   e->show_insert_position();
-  if (e->when()&FL_WHEN_CHANGED) e->do_callback(); else e->set_changed();
+  if (e->when()&FL_WHEN_CHANGED) e->do_callback();
+  else e->set_changed();
   return 1;
 }
 
@@ -401,8 +402,7 @@
 }
 
 int Fl_Text_Editor::handle_key() {
-
-  // Call fltk's rules to try to turn this into a printing character.
+  // Call FLTK's rules to try to turn this into a printing character.
   // This uses the right-hand ctrl key as a "compose prefix" and returns
   // the changes that should be made to the text, as a number of
   // bytes to delete and a string to insert:
@@ -415,6 +415,8 @@
       else overstrike(Fl::event_text());
     }
     show_insert_position();
+    if (when()&FL_WHEN_CHANGED) do_callback();
+    else set_changed();
     return 1;
   }
 
@@ -423,13 +425,14 @@
   Key_Func f;
   f = bound_key_function(key, state, global_key_bindings);
   if (!f) f = bound_key_function(key, state, key_bindings);
-
   if (f) return f(key, this);
   if (default_key_function_ && !state) return default_key_function_(c, this);
   return 0;
 }
 
 void Fl_Text_Editor::maybe_do_callback() {
+//  printf("Fl_Text_Editor::maybe_do_callback()\n");
+//  printf("changed()=%d, when()=%x\n", changed(), when());
   if (changed() || (when()&FL_WHEN_NOT_CHANGED)) {
     clear_changed(); do_callback();}
 }
